"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/@code-like-a-carpenter/foundation-plugin-cloudformation/src/cdc/reactor.ts
var reactor_exports = {};
__export(reactor_exports, {
  defineReactor: () => defineReactor
});
module.exports = __toCommonJS(reactor_exports);
var import_combine_fragments = require("../fragments/combine-fragments.cjs");
var import_handler = require("./handler.cjs");
function defineReactor(config, model, cdc) {
  const {
    actionsModuleId,
    handlerImportName,
    handlerModuleId,
    runtimeModuleId,
    sourceModelName
  } = cdc;
  const { dependenciesModuleId } = model.table;
  const code = `// This file is generated. Do not edit by hand.
import {makeReactor} from '${runtimeModuleId}';
import {${handlerImportName}} from '${handlerModuleId}';
import type {${sourceModelName}, unmarshall${sourceModelName}} from '${actionsModuleId}';
import * as dependencies from '${dependenciesModuleId}';

export const handler = makeReactor<${sourceModelName}>(${handlerImportName}, {unmarshallSourceModel: unmarshall${sourceModelName}}, dependencies);
`;
  const { fragment, stack } = (0, import_handler.makeHandler)(config, model, cdc, code);
  return { fragment: (0, import_combine_fragments.combineFragments)(fragment), stack };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  defineReactor
});
//# sourceMappingURL=reactor.cjs.map
