"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/@code-like-a-carpenter/foundation-plugin-cloudformation/src/cdc/table.ts
var table_exports = {};
__export(table_exports, {
  defineTableCdc: () => defineTableCdc
});
module.exports = __toCommonJS(table_exports);
var import_combine_fragments = require("../fragments/combine-fragments.cjs");
var import_lambda = require("../fragments/lambda.cjs");
var import_dispatcher = require("../stacks/dispatcher.cjs");
function defineTableCdc(table, config) {
  const { dispatcherConfig, dependenciesModuleId, tableName } = table;
  const {
    batchSize,
    filename,
    directory,
    maximumRetryAttempts,
    memorySize,
    nestedStackLocation,
    runtimeModuleId,
    timeout
  } = dispatcherConfig;
  (0, import_lambda.writeLambda)(
    directory,
    `// This file is generated. Do not edit by hand.

import {makeDynamoDBStreamDispatcher} from '${runtimeModuleId}';
import * as dependencies from '${dependenciesModuleId}';

export const handler = makeDynamoDBStreamDispatcher({
  ...dependencies,
  tableName: '${tableName}',
});
`
  );
  const stack = {
    Properties: {
      Location: nestedStackLocation,
      Parameters: {
        BatchSize: batchSize,
        CodeUri: filename,
        EventBus: "default",
        MaximumRetryAttempts: maximumRetryAttempts,
        MemorySize: memorySize,
        StreamArn: { "Fn::GetAtt": [tableName, "StreamArn"] },
        Timeout: timeout
      }
    },
    Type: "AWS::Serverless::Application"
  };
  const stackName = (0, import_dispatcher.makeDispatcherStackName)(table);
  const fragment = (0, import_combine_fragments.combineFragments)({
    Resources: {
      [stackName]: stack
    }
  });
  const dispatcherStack = (0, import_dispatcher.makeDispatcherStack)(config);
  return { fragment, stack: dispatcherStack };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  defineTableCdc
});
//# sourceMappingURL=table.cjs.map
