"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/@code-like-a-carpenter/foundation-plugin-cloudformation/src/config.ts
var config_exports = {};
__export(config_exports, {
  ConfigSchema: () => ConfigSchema
});
module.exports = __toCommonJS(config_exports);
var import_zod = require("zod");
var import_foundation_parser = require("@code-like-a-carpenter/foundation-parser");
var BuildPropertiesSchema = import_zod.z.object({
  external: import_zod.z.array(import_zod.z.string()).default(["@aws-sdk/*"]),
  minify: import_zod.z.boolean().default(false),
  sourcemap: import_zod.z.boolean().default(true),
  target: import_zod.z.string().default("es2022")
});
var DumpOptions = import_zod.z.object({
  condenseFlow: import_zod.z.boolean().optional(),
  flowLevel: import_zod.z.number().optional(),
  forceQuotes: import_zod.z.boolean().default(true),
  indent: import_zod.z.number().optional(),
  lineWidth: import_zod.z.number().optional(),
  noArrayIndent: import_zod.z.boolean().optional(),
  noCompatMode: import_zod.z.boolean().optional(),
  noRefs: import_zod.z.boolean().default(true),
  quotingType: import_zod.z.enum([`'`, `"`]).default(`'`),
  skipInvalid: import_zod.z.boolean().optional(),
  sortKeys: import_zod.z.boolean().default(true)
});
var ConfigSchema = import_foundation_parser.ParserConfigSchema.extend({
  actionsModuleId: import_zod.z.string(),
  buildProperties: BuildPropertiesSchema.default({}),
  cloudformationTransforms: import_zod.z.array(import_zod.z.string()).default(["@code-like-a-carpenter/foundation-transform-environment"]),
  outputConfig: import_zod.z.object({
    format: import_zod.z.enum(["json", "yaml"]).default("json"),
    yamlConfig: DumpOptions.default({})
  }).default({}),
  singleQueueKey: import_zod.z.boolean().default(false),
  sourceTemplate: import_zod.z.string().optional()
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ConfigSchema
});
//# sourceMappingURL=config.cjs.map
