"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/@code-like-a-carpenter/foundation-plugin-cloudformation/src/fragments/kms-key.ts
var kms_key_exports = {};
__export(kms_key_exports, {
  makeKmsKey: () => makeKmsKey
});
module.exports = __toCommonJS(kms_key_exports);
function makeKmsKey() {
  return {
    Properties: {
      KeyPolicy: {
        Statement: [
          {
            Action: ["kms:Decrypt", "kms:GenerateDataKey"],
            Effect: "Allow",
            Principal: {
              Service: "events.amazonaws.com"
            },
            Resource: "*",
            Sid: "Allow EventBridge to use the Key"
          },
          {
            Action: [
              "kms:Create*",
              "kms:Describe*",
              "kms:Enable*",
              "kms:List*",
              "kms:Put*",
              "kms:Update*",
              "kms:Revoke*",
              "kms:Disable*",
              "kms:Get*",
              "kms:Delete*",
              "kms:ScheduleKeyDeletion",
              "kms:CancelKeyDeletion"
            ],
            Effect: "Allow",
            Principal: {
              AWS: {
                // eslint-disable-next-line no-template-curly-in-string
                "Fn::Sub": "arn:aws:iam::${AWS::AccountId}:root"
              }
            },
            Resource: "*",
            Sid: "Allow administration of the key"
          },
          {
            Action: [
              "kms:Encrypt",
              "kms:Decrypt",
              "kms:ReEncrypt*",
              "kms:GenerateDataKey*",
              "kms:CreateGrant",
              "kms:DescribeKey"
            ],
            Condition: {
              StringEquals: {
                "kms:CallerAccount": {
                  // eslint-disable-next-line no-template-curly-in-string
                  "Fn::Sub": "${AWS::AccountId}"
                },
                "kms:ViaService": "sqs.us-east-1.amazonaws.com"
              }
            },
            Effect: "Allow",
            Principal: {
              AWS: "*"
            },
            Resource: "*",
            Sid: "Allow authorized SQS callers to access the key"
          },
          {
            Action: [
              "kms:Describe*",
              "kms:Get*",
              "kms:List*",
              "kms:RevokeGrant"
            ],
            Effect: "Allow",
            Principal: {
              AWS: {
                // eslint-disable-next-line no-template-curly-in-string
                "Fn::Sub": "arn:aws:iam::${AWS::AccountId}:root"
              }
            },
            Resource: "*",
            Sid: "Allow direct access to key metadata to the account"
          }
        ],
        Version: "2012-10-17"
      },
      PendingWindowInDays: 7
    },
    Type: "AWS::KMS::Key"
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  makeKmsKey
});
//# sourceMappingURL=kms-key.cjs.map
