"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/@code-like-a-carpenter/foundation-plugin-cloudformation/src/fragments/log-group.ts
var log_group_exports = {};
__export(log_group_exports, {
  makeLogGroup: () => makeLogGroup
});
module.exports = __toCommonJS(log_group_exports);
function makeLogGroup({
  functionName
}) {
  const logGroup = {
    Properties: {
      // @ts-expect-error typedef doesn't include intrinsic functions
      LogGroupName: { "Fn::Sub": `/aws/lambda/\${${functionName}}` },
      // @ts-expect-error typedef doesn't include intrinsic functions
      RetentionInDays: { Ref: "LogRetentionInDays" }
    },
    Type: "AWS::Logs::LogGroup"
  };
  return {
    Outputs: {
      LogGroupName: {
        Export: {
          // eslint-disable-next-line no-template-curly-in-string
          Name: { "Fn::Sub": "${AWS::StackName}-LogGroupName" }
        },
        Value: { Ref: `${functionName}LogGroup` }
      }
    },
    Parameters: {
      LogRetentionInDays: {
        Default: "3",
        Description: "Log retention in days",
        Type: "Number"
      }
    },
    Resources: {
      [`${functionName}LogGroup`]: logGroup
    }
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  makeLogGroup
});
//# sourceMappingURL=log-group.cjs.map
