"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/@code-like-a-carpenter/foundation-plugin-cloudformation/src/stacks/dispatcher.ts
var dispatcher_exports = {};
__export(dispatcher_exports, {
  isDispatcherStack: () => isDispatcherStack,
  makeDispatcherStack: () => makeDispatcherStack,
  makeDispatcherStackName: () => makeDispatcherStackName
});
module.exports = __toCommonJS(dispatcher_exports);
var import_combine_fragments = require("../fragments/combine-fragments.cjs");
var import_log_group = require("../fragments/log-group.cjs");
function isDispatcherStack(resourceName) {
  return resourceName.startsWith("FNDNSTD");
}
function makeDispatcherStackName(table) {
  return `FNDNSTD${table.dispatcherConfig.functionName}`;
}
function makeDispatcherStack(config) {
  const functionName = "Function";
  const fn = {
    Metadata: {
      BuildMethod: "esbuild",
      buildProperties: {
        EntryPoints: ["./index"],
        External: config.buildProperties.external,
        Minify: config.buildProperties.minify,
        Sourcemap: config.buildProperties.sourcemap,
        Target: config.buildProperties.target
      }
    },
    Properties: {
      // @ts-expect-error - typedef does not know about intrinsic functions
      CodeUri: { Ref: "CodeUri" },
      Events: {
        Stream: {
          Properties: {
            BatchSize: { Ref: "BatchSize" },
            FunctionResponseTypes: ["ReportBatchItemFailures"],
            MaximumRetryAttempts: { Ref: "MaximumRetryAttempts" },
            StartingPosition: "TRIM_HORIZON",
            Stream: { Ref: "StreamArn" }
          },
          Type: "DynamoDB"
        }
      },
      Handler: "index.handler",
      MemorySize: { Ref: "MemorySize" },
      Policies: [
        "AWSLambdaBasicExecutionRole",
        "AWSLambda_ReadOnlyAccess",
        "AWSXrayWriteOnlyAccess",
        "CloudWatchLambdaInsightsExecutionRolePolicy",
        { CloudWatchPutMetricPolicy: {} },
        {
          EventBridgePutEventsPolicy: {
            EventBusName: { Ref: "EventBus" }
          }
        }
      ],
      Runtime: "nodejs18.x",
      Timeout: { Ref: "Timeout" },
      Tracing: "Active"
    },
    Type: "AWS::Serverless::Function"
  };
  return (0, import_combine_fragments.combineFragments)((0, import_log_group.makeLogGroup)({ functionName }), {
    AWSTemplateFormatVersion: "2010-09-09",
    Outputs: {
      FunctionName: {
        Export: {
          // eslint-disable-next-line no-template-curly-in-string
          Name: { "Fn::Sub": "${AWS::StackName}-FunctionName" }
        },
        Value: { Ref: "Function" }
      }
    },
    Parameters: {
      BatchSize: {
        Type: "Number"
      },
      CodeUri: {
        Type: "String"
      },
      EventBus: {
        Type: "String"
      },
      MaximumRetryAttempts: {
        Type: "Number"
      },
      MemorySize: {
        Type: "Number"
      },
      StreamArn: {
        Type: "String"
      },
      Timeout: {
        Type: "Number"
      }
    },
    Resources: {
      [functionName]: fn
    },
    Transform: "AWS::Serverless-2016-10-31"
  });
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  isDispatcherStack,
  makeDispatcherStack,
  makeDispatcherStackName
});
//# sourceMappingURL=dispatcher.cjs.map
