"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/@code-like-a-carpenter/foundation-plugin-cloudformation/src/template-transforms/globals.ts
var globals_exports = {};
__export(globals_exports, {
  globalsTransform: () => globalsTransform
});
module.exports = __toCommonJS(globals_exports);
var import_assert = require("@code-like-a-carpenter/assert");
var import_stacks = require("../stacks/index.cjs");
var globalsTransform = (template, nestedTemplates) => {
  Object.entries(template.Resources).filter(
    ([resourceName, resource]) => resource.Type === "AWS::Serverless::Application" && ((0, import_stacks.isDispatcherStack)(resourceName) || (0, import_stacks.isHandlerStack)(resourceName))
  ).forEach(([, resource]) => {
    (0, import_assert.assert)(
      resource.Type === "AWS::Serverless::Application",
      "Resource must be a Serverless Application"
    );
    const refs = findRefs(template.Globals ?? {});
    Object.values(nestedTemplates).forEach((tpl) => {
      tpl.Parameters = tpl.Parameters ?? {};
      for (const ref of refs) {
        tpl.Parameters[ref] = {
          Type: "String"
        };
      }
      tpl.Globals = template.Globals;
    });
    (0, import_assert.assert)(resource.Properties, "Resource must have Properties");
    resource.Properties.Parameters = resource.Properties.Parameters ?? {};
    const Parameters = resource.Properties.Parameters;
    for (const ref of refs) {
      Parameters[ref] = `\${${ref}}`;
    }
  });
};
function findRefs(obj) {
  return Object.entries(obj).reduce((acc, [key, value]) => {
    if (typeof value === "object" && value !== null && !Array.isArray(value)) {
      return acc.concat(findRefs(value));
    }
    if (key === "Ref") {
      (0, import_assert.assert)(typeof value === "string", "Ref value must be a string");
      return acc.concat([value]);
    }
    return acc;
  }, []);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  globalsTransform
});
//# sourceMappingURL=globals.cjs.map
