// packages/@code-like-a-carpenter/foundation-plugin-cloudformation/src/cdc/reactor.ts
import { combineFragments } from "../fragments/combine-fragments.mjs";
import { makeHandler } from "./handler.mjs";
function defineReactor(config, model, cdc) {
  const {
    actionsModuleId,
    handlerImportName,
    handlerModuleId,
    runtimeModuleId,
    sourceModelName
  } = cdc;
  const { dependenciesModuleId } = model.table;
  const code = `// This file is generated. Do not edit by hand.
import {makeReactor} from '${runtimeModuleId}';
import {${handlerImportName}} from '${handlerModuleId}';
import type {${sourceModelName}, unmarshall${sourceModelName}} from '${actionsModuleId}';
import * as dependencies from '${dependenciesModuleId}';

export const handler = makeReactor<${sourceModelName}>(${handlerImportName}, {unmarshallSourceModel: unmarshall${sourceModelName}}, dependencies);
`;
  const { fragment, stack } = makeHandler(config, model, cdc, code);
  return { fragment: combineFragments(fragment), stack };
}
export {
  defineReactor
};
//# sourceMappingURL=reactor.mjs.map
