// packages/@code-like-a-carpenter/foundation-plugin-cloudformation/src/fragments/log-group.ts
function makeLogGroup({
  functionName
}) {
  const logGroup = {
    Properties: {
      // @ts-expect-error typedef doesn't include intrinsic functions
      LogGroupName: { "Fn::Sub": `/aws/lambda/\${${functionName}}` },
      // @ts-expect-error typedef doesn't include intrinsic functions
      RetentionInDays: { Ref: "LogRetentionInDays" }
    },
    Type: "AWS::Logs::LogGroup"
  };
  return {
    Outputs: {
      LogGroupName: {
        Export: {
          // eslint-disable-next-line no-template-curly-in-string
          Name: { "Fn::Sub": "${AWS::StackName}-LogGroupName" }
        },
        Value: { Ref: `${functionName}LogGroup` }
      }
    },
    Parameters: {
      LogRetentionInDays: {
        Default: "3",
        Description: "Log retention in days",
        Type: "Number"
      }
    },
    Resources: {
      [`${functionName}LogGroup`]: logGroup
    }
  };
}
export {
  makeLogGroup
};
//# sourceMappingURL=log-group.mjs.map
