// packages/@code-like-a-carpenter/foundation-plugin-cloudformation/src/transforms.ts
async function applyTransforms(config, ir, template, nestedTemplates) {
  for (const transformModule of config.cloudformationTransforms) {
    const transform = await loadTransform(transformModule);
    await transform(ir, template, nestedTemplates);
  }
}
async function loadTransform(transformModule) {
  const mod = await import(transformModule);
  if (mod.default) {
    return mod.default.transform;
  }
  return mod.transform;
}
export {
  applyTransforms
};
//# sourceMappingURL=transforms.mjs.map
